#ifndef	_fifo_h_
#define	_fifo_h_

#include "utype.h"

/****************************************************************
 *	 fifo  o
 ****************************************************************
 *	
 */
typedef	struct {
	uchar *buf;			// FIFOobt@.
	int    size;		// FIFOobt@̃TCY.
	int    inPtr;		// lߍ݃|C^. (0 .. size-1)
	int    outPtr;		// o|C^. (0 .. size-1)
} FIFO;

int FIFO_init( FIFO *queue,uchar *buf,int size);	//.
int FIFO_enqueue(FIFO *queue,uchar *buf,int size);	//L[ɂ߂.
int FIFO_dequeue(FIFO *queue,uchar *buf,int size);	//L[o.
int FIFO_getsize(FIFO *queue);					//L[ɂ܂ĂoCg𓾂.
int FIFO_getfreesize(FIFO *queue);				//L[̋󂫗eʃoCg𓾂.
int FIFO_reset( FIFO *queue );
int FIFO_drop(FIFO *queue,int size);			//L[sizeoCĝĂ.
int FIFO_getnewdata(FIFO *queue,uchar *buf,int size);//L[̐VقsizeoCgRs[.

int	align_size(int p,int align);	//؂グ.
int	floor_size(int p,int align);	//؂̂.

/****************************************************************
 *	
 ****************************************************************
 */

#endif
