/*************************************************************************
 *	SamplinǧĂяo.
 *************************************************************************
 *
	int StartSample(SAMPLE_PARAM *param);	//TvOJn.
	int StopSample();						//TvO~.

// StartSample(param)sȂƁAǂݍݐp̃XbhFIFOɓǂݍݑ.
// ReadSample(buf,size)ɂāAf[^.

	int	ReadSample(char *buf,int size,int nowait);	//TvOf[^ǂݎ.

// ŐṼf[^sizeoCg擾. 擾oCgԂ.
// nowait=1̂ƂsizeoCgɖȂꍇłƂ肠擾đ^[.

ӓ_:
	// ReadSamplesȂĂÃf[^Âłۏ؂͂Ȃ.
	// iReadSampleĂяoꂽ_ł̍ŐVf[^󂯎Ƃj
	// Ȃ̂ŁAPʕ̃f[^͈xɎ擾悤ɂ.
*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "config.h"
#include "dllcall.h"

#include "sampling.h"
#include "fifo.h"

#define		DEBUG			0
#define		FIFO_SIZE		0x400000	// 4MB
//#define		FIFO_SIZE		0x100000	// 1MB
//#define		FIFO_SIZE		0x10000	// 64kB

//	Xbhԃf[^󂯓n̂߂̍\.
static	THREAD_PARAM s_param;
static	HANDLE  s_thread ;		// Read Xbh̃nh.
static	DWORD   s_thid;

static	FIFO 	s_fifo_queue;
static	FIFO   *queue = &s_fifo_queue;
static	u_char *s_fifo_buf;

#define	PACKET_SIZE		60			// USBR}hPpPbgbyte size
#define	RBUF_SIZE		(1024+16)	// 1̃TvOf[^擾byte size(wb_[)


extern	int		device_id;
		int		g_debug_count;
/*************************************************************************
 *
 *************************************************************************
 */
void memdump(char *msg, char *buf, int len)
{
	int j;
	fprintf(stderr, "%s", msg);
	for (j = 0; j < len; j++) {
		fprintf(stderr, " %02x", buf[j] & 0xff);
		if((j & 0xf)==  7)
			fprintf(stderr, " ");

		if((j & 0xf)== 15)
			fprintf(stderr, "\n +");
	}
	fprintf(stderr, "\n");
}


/*************************************************************************
 *
 *************************************************************************
 */
int StartSample(SAMPLE_PARAM *param)
{
	if(device_id==0) return -1;
#if	DEBUG
	printf("StartSample()\n");
#endif
	THREAD_PARAM *p = &s_param;
	p->param = *param;
	p->cmd = THREAD_START;

#if	0
	printf("StartSample() size = %d ADST0=%02x chs=%04x\n"
		,s_param.param.size
		,s_param.param.rate
		,s_param.param.channels
	);
#endif
	return 0;
}
/*************************************************************************
 *
 *************************************************************************
 */
int	StopSample(void)
{
	if(device_id==0) return -1;
#if	DEBUG
	printf("StopSample()\n");
#endif
	THREAD_PARAM *p = &s_param;
	p->cmd = THREAD_PAUSE;
	return 0;
}

/*************************************************************************
 *	TvOf[^ǂݎ.
 *************************************************************************
 */
int	ReadSample(char *buf,int size,int nowait)
{
	int retry=0;
	int qsize;

	for(retry=0;retry<3;retry++) {
		qsize = FIFO_getnewdata(queue,(u_char*)buf,size);	//L[o.
#if	DEBUG
		printf("ReadSample()=%d/%d\n",qsize,size);
#endif
		if( qsize >= size ) break;

		Sleep(1);
	}

#if	0
	THREAD_PARAM *p = &s_param;
	if( p->cmd == THREAD_OVERRUN ) 
	{
		printf("1)ReadSample()=%d/%d\n",qsize,size);
		FIFO_reset(queue);
		p->param.dummy++;
		p->cmd = THREAD_READ;
		Sleep(10);
	}

	if(qsize < size) {
		printf("2)ReadSample()=%d/%d\n",qsize,size);
	}
#endif
	return qsize;
}

/*************************************************************************
 *			Xbh~
 *************************************************************************
 */
void StopThread()
{
	if(	s_thread ) {
		s_param.cmd=THREAD_EXIT;
		Sleep(300);
		s_thread = 0;
	}

}

/*************************************************************************
			TvOJn.
 *************************************************************************
 */
static	int	sample_start(SAMPLE_PARAM *param)
{
	char cmdbuf[64];

	cmdbuf[0]=0x01;		// preamble.
	memcpy(cmdbuf+1,param,sizeof(SAMPLE_PARAM));
	sendCommand(cmdbuf,PACKET_SIZE);
	return 0;
}
/*************************************************************************
			TvOf[^擾.
 *************************************************************************
 */
static	int	sample_read(char *buf,int size)
{
	SAMPLE_PARAM *p=(SAMPLE_PARAM *)buf;
	getResult(buf,size);
	return p->size;
}

/*************************************************************************
			TvO~.
 *************************************************************************
 */
static	int	sample_stop()
{
	SAMPLE_PARAM buf;
	memset(&buf,0,sizeof(buf));
	sample_start(&buf);
	return 0;
}

/*************************************************************************
			ؒf
 *************************************************************************
 */
static void	RS_disconnect()
{
	char cmdbuf[64];
	memset(cmdbuf,0xff,64);
	sendCommand(cmdbuf,PACKET_SIZE);
//	sendCommand(cmdbuf,PACKET_SIZE);
}

/*************************************************************************
 *	FIFOɗD挠tŃf[^𗭂߂.
 *************************************************************************
 */
void FIFO_enqueue_prior(FIFO *queue,uchar *buf,int size)
{
	//
	//	FIFŐ󂫂ȂƂ́A󂯂.
	//
	int fre = FIFO_getfreesize(queue);
	if(	fre < size ) {
		FIFO_drop(queue,align_size(size,16 * sizeof(short) ));
	}
	//
	//	FIFOɂ߂.
	//
	FIFO_enqueue(queue,buf,size);
}
/*************************************************************************
 *	USB READ Xbh
 *************************************************************************
 */
DWORD WINAPI read_thread(LPVOID param)
{
	THREAD_PARAM *p = &s_param;
	SAMPLE_RETURN *result;
	char rbuf[RBUF_SIZE];
	int size =RBUF_SIZE;
	int getsize;


	while(1) {
		if(p->cmd == THREAD_EXIT) {
			sample_stop();
			Sleep(30);
//			RS_disconnect();
			break;
		}
		switch(p->cmd) {
		 case THREAD_IDLE:
			Sleep(1);
			break;
		 case THREAD_OVERRUN:
			Sleep(1);
			break;
		 case THREAD_START:
			FIFO_init( queue , s_fifo_buf , FIFO_SIZE);
			p->cmd=THREAD_READ;
//			Sleep(1);
			break;
		 case THREAD_READ:
			sample_start(&p->param);
			getsize = sample_read(rbuf,size);

			result=(SAMPLE_RETURN *)rbuf;
			if(result->overrun == 1) {	//Overrun!
				FIFO_reset( queue );
			}
			g_debug_count = result->debug_cnt;

#if	0
//			static int cnt = 0;
			if(result->overrun == 1) {	//Overrun!
//				sample_stop();
//			 	p->cmd = THREAD_OVERRUN;
//				printf("!overrun %d\n",cnt++);
			}else
#endif
			{
				FIFO_enqueue_prior(queue,(u_char*)rbuf+16,getsize);	//L[ɂ߂.
			}
			break;
		 case THREAD_PAUSE:
			sample_stop();
		 	p->cmd = THREAD_IDLE;
			break;
		}
	}
	return 0;
}


/*************************************************************************
 *
 *************************************************************************
 */

int	InitSample()
{
	//
	//	FIFȌ.
	//
	s_fifo_buf = malloc(FIFO_SIZE);
	FIFO_init( queue , s_fifo_buf , FIFO_SIZE);

	if(	device_id==0) {
		device_id = openDevice(0,0);
		printf("device_id = %x\n",device_id);
	}
	//
	//	USB READ XbhN.
	//
	s_thread = CreateThread(NULL, 0, read_thread, NULL, 0, &s_thid);
	return 0;
}
/*************************************************************************
 *
 *************************************************************************
 */

